OpenTTD Source: NWidgetMatrix Class Reference

OpenTTD Source 14.0-RC3

Public Member Functions | Protected Attributes | Private Member Functions | Private Attributes
NWidgetMatrix Class Reference
Hierarchical widgets

Matrix container with implicitly equal sized (virtual) sub-widgets. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetMatrix:

## Public Member Functions
| NWidgetMatrix (Colours colour, WidgetID index)
void | SetClicked (int clicked)
| Sets the clicked element in the matrix. More...
void | SetCount (int count)
| Set the number of elements in this matrix. More...
void | SetScrollbar (Scrollbar *sb)
| Assign a scrollbar to this matrix. More...
int | GetCurrentElement () const
| Get current element. More...
void | SetupSmallestSize (Window *w) override
void | AssignSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height, bool rtl) override
void | FillWidgetLookup (WidgetLookup &widget_lookup) override
NWidgetCore * | GetWidgetFromPos (int x, int y) override
void | Draw (const Window *w) override
Public Member Functions inherited from NWidgetPIPContainer
| NWidgetPIPContainer (WidgetType tp, NWidContainerFlags flags=NC_NONE)
void | AdjustPaddingForZoom () override
void | SetPIP (uint8_t pip_pre, uint8_t pip_inter, uint8_t pip_post)
| Set additional pre/inter/post space for the container. More...
void | SetPIPRatio (uint8_t pip_ratio_pre, uint8_t pip_ratio_inter, uint8_t pip_rato_post)
| Set additional pre/inter/post space for the container. More...
Public Member Functions inherited from NWidgetContainer
| NWidgetContainer (WidgetType tp)
void | Add (std::unique_ptr< NWidgetBase > &&wid)
| Append widget wid to container. More...
bool | IsEmpty ()
| Return whether the container is empty.
NWidgetBase * | GetWidgetOfType (WidgetType tp) override
| Retrieve a widget by its type. More...
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor. More...
template<class NWID >
NWID * | GetParentWidget ()
| Get parent widget of type NWID. More...
template<class NWID >
const NWID * | GetParentWidget () const
| Get parent widget of type NWID. More...
virtual bool | IsHighlighted () const
virtual TextColour | GetHighlightColour () const
virtual void | SetHighlighted ([[maybe_unused]] TextColour highlight_colour)
void | SetPadding (uint8_t top, uint8_t right, uint8_t bottom, uint8_t left)
| Set additional space (padding) around the widget. More...
void | SetPadding (const RectPadding &padding)
| Set additional space (padding) around the widget. More...
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step. More...
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step. More...
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint). More...
Rect | GetCurrentRect () const
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance. More...
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances. More...
void | operator delete (void *ptr)
| Memory release for a single class instance. More...
void | operator delete[] (void *ptr)
| Memory release for an array of class instances. More...

## Protected Attributes
const WidgetID | index
| If non-negative, index in the Window::widget_lookup.
Colours | colour
| Colour of this widget.
int | clicked
| The currently clicked element.
int | count
| Amount of valid elements.
int | current_element
| The element currently being processed.
Scrollbar * | sb
| The scrollbar we're associated with.
Protected Attributes inherited from NWidgetPIPContainer
NWidContainerFlags | flags
| Flags of the container.
uint8_t | pip_pre
| Amount of space before first widget.
uint8_t | pip_inter
| Amount of space between widgets.
uint8_t | pip_post
| Amount of space after last widget.
uint8_t | pip_ratio_pre
| Ratio of remaining space before first widget.
uint8_t | pip_ratio_inter
| Ratio of remaining space between widgets.
uint8_t | pip_ratio_post
| Ratio of remaining space after last widget.
uint8_t | uz_pip_pre
| Unscaled space before first widget.
uint8_t | uz_pip_inter
| Unscaled space between widgets.
uint8_t | uz_pip_post
| Unscaled space after last widget.
uint8_t | gaps
| Number of gaps between widgets.
Protected Attributes inherited from NWidgetContainer
std::vector< std::unique_ptr< NWidgetBase > > | children
| Child widgets in contaier.

## Private Member Functions
void | GetScrollOffsets (int &start_x, int &start_y, int &base_offs_x, int &base_offs_y)
| Get the different offsets that are influenced by scrolling. More...

## Private Attributes
int | widget_w
| The width of the child widget including inter spacing.
int | widget_h
| The height of the child widget including inter spacing.
int | widgets_x
| The number of visible widgets in horizontal direction.
int | widgets_y
| The number of visible widgets in vertical direction.

## Additional Inherited Members
Data Fields inherited from NWidgetBase
WidgetType | type
| Type of the widget / nested widget.
uint | fill_x
| Horizontal fill stepsize (from initial size, `0` means not resizable).
uint | fill_y
| Vertical fill stepsize (from initial size, `0` means not resizable).
uint | resize_x
| Horizontal resize step (`0` means not resizable).
uint | resize_y
| Vertical resize step (`0` means not resizable).
uint | smallest_x
| Smallest horizontal size of the widget in a filled window.
uint | smallest_y
| Smallest vertical size of the widget in a filled window.
uint | current_x
| Current horizontal size (after resizing).
uint | current_y
| Current vertical size (after resizing).
int | pos_x
| Horizontal position of top-left corner of the widget in the window.
int | pos_y
| Vertical position of top-left corner of the widget in the window.
RectPadding | padding
| Padding added to the widget. Managed by parent container widget. (parent container may swap left and right for RTL)
RectPadding | uz_padding
| Unscaled padding, for resize calculation.
NWidgetBase * | parent
| Parent widget of this widget, automatically filled in when added to container.
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, int x, int y, uint given_width, uint given_height)
| Store size and position. More...

## Detailed Description

Matrix container with implicitly equal sized (virtual) sub-widgets.

This widget must have exactly one sub-widget. After that this sub-widget is used to draw all of the data within the matrix piece by piece. DrawWidget and OnClick calls will be done to that sub-widget, where the 16 high bits are used to encode the index into the matrix.

Definition at line 583 of file widget_type.h.

## Member Function Documentation

## ◆ AssignSizePosition()

void NWidgetMatrix::AssignSizePosition | ( | SizingType | sizing,
|  | int | x,
|  | int | y,
|  | uint | given_width,
|  | uint | given_height,
|  | bool | rtl
| ) |  |
| overridevirtual

Assign size and position to the widget.

Parameters

  sizing | Type of resizing to perform.
  x | Horizontal offset of the widget relative to the left edge of the window.
  y | Vertical offset of the widget relative to the top edge of the window.
  given_width | Width allocated to the widget.
  given_height | Height allocated to the widget.
  rtl | Adapt for right-to-left languages (position contents of horizontal containers backwards).

Afterwards, pos_x and pos_y contain the top-left position of the widget, smallest_x and smallest_y contain the smallest size such that all widgets of the window are consistent, and current_x and current_y contain the current size.

Implements NWidgetBase.

Definition at line 1846 of file widget.cpp.

## ◆ Draw()

void NWidgetMatrix::Draw | ( | const Window * | w | ) |
| overridevirtual

Draw the widgets of the tree. The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters

  w | Window that owns the tree.

Reimplemented from NWidgetContainer.

Definition at line 1906 of file widget.cpp.

References _colour_gradient, _current_text_dir, colour, NWidgetBase::current_x, NWidgetBase::current_y, FillDrawPixelInfo(), GfxFillRect(), NWidgetPIPContainer::pip_post, NWidgetPIPContainer::pip_pre, NWidgetBase::pos_x, NWidgetBase::pos_y, and TD_RTL.

## ◆ FillWidgetLookup()

void NWidgetMatrix::FillWidgetLookup | ( | WidgetLookup & | widget_lookup | ) |
| overridevirtual

Fill the Window::widget_lookup with pointers to nested widgets in the tree.

Parameters

  widget_lookup | The WidgetLookup.

Reimplemented from NWidgetContainer.

Definition at line 1870 of file widget.cpp.

References NWidgetContainer::FillWidgetLookup(), and index.

## ◆ GetCurrentElement()

int NWidgetMatrix::GetCurrentElement | ( |  | ) | const

Get current element.

Returns
  index of current element.

Definition at line 1820 of file widget.cpp.

References current_element.

## ◆ GetScrollOffsets()

void NWidgetMatrix::GetScrollOffsets | ( | int & | start_x,
|  | int & | start_y,
|  | int & | base_offs_x,
|  | int & | base_offs_y
| ) |  |
| private

Get the different offsets that are influenced by scrolling.

Parameters

  [out] | start_x | The start position in columns (index of the left-most column, swapped in RTL).
  [out] | start_y | The start position in rows.
  [out] | base_offs_x | The base horizontal offset in pixels (X position of the column start_x).
  [out] | base_offs_y | The base vertical offset in pixels (Y position of the column start_y).

Definition at line 1961 of file widget.cpp.

References _current_text_dir, Scrollbar::GetPosition(), Scrollbar::IsVertical(), sb, TD_RTL, widget_h, widget_w, and widgets_x.

## ◆ GetWidgetFromPos()

NWidgetCore * NWidgetMatrix::GetWidgetFromPos | ( | int | x,
|  | int | y
| ) |  |
| overridevirtual

Retrieve a widget by its position.

Parameters

  x | Horizontal position relative to the left edge of the window.
  y | Vertical position relative to the top edge of the window.

Returns
  Returns the deepest nested widget that covers the given position, or `nullptr` if no widget can be found.

Reimplemented from NWidgetContainer.

Definition at line 1876 of file widget.cpp.

## ◆ SetClicked()

void NWidgetMatrix::SetClicked | ( | int | clicked | ) |

Sets the clicked element in the matrix.

Parameters

  clicked | The clicked element.

Definition at line 1770 of file widget.cpp.

References clicked, Scrollbar::GetPosition(), NWidgetPIPContainer::pip_inter, sb, Scrollbar::ScrollTowards(), widget_h, and widgets_x.

## ◆ SetCount()

void NWidgetMatrix::SetCount | ( | int | count | ) |

Set the number of elements in this matrix.

Note
  Updates the number of elements/capacity of the real scrollbar.

Parameters

  count | The number of elements.

Definition at line 1787 of file widget.cpp.

References CeilDiv(), count, NWidgetBase::current_x, NWidgetBase::current_y, Scrollbar::IsVertical(), NWidgetPIPContainer::pip_inter, NWidgetPIPContainer::pip_post, NWidgetPIPContainer::pip_pre, sb, Scrollbar::SetCapacity(), Scrollbar::SetCount(), Scrollbar::SetStepSize(), widget_h, widget_w, and widgets_x.

## ◆ SetScrollbar()

void NWidgetMatrix::SetScrollbar | ( | Scrollbar * | sb | ) |

Assign a scrollbar to this matrix.

Parameters

  sb | The scrollbar to assign to us.

Definition at line 1811 of file widget.cpp.

References sb.

## ◆ SetupSmallestSize()

void NWidgetMatrix::SetupSmallestSize | ( | Window * | w | ) |
| overridevirtual

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters

  w | Window owning the widget.

Note
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Definition at line 1825 of file widget.cpp.

References NWidgetBase::padding.

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp